Botan: Botan::WiderWake_41_BE Class Reference

Botan 1.10.16

Public Member Functions | List of all members
Botan::WiderWake_41_BE Class Reference

`#include <wid_wake.h>`

Inheritance diagram for Botan::WiderWake_41_BE:

## Public Member Functions
void | cipher (const byte[], byte[], size_t)
void | cipher1 (byte buf[], size_t len)
void | clear ()
StreamCipher * | clone () const
Key_Length_Specification | key_spec () const
size_t | maximum_keylength () const
size_t | minimum_keylength () const
std::string | name () const
void | set_iv (const byte[], size_t)
void | set_key (const SymmetricKey &key)
void | set_key (const byte key[], size_t length)
bool | valid_iv_length (size_t iv_len) const
bool | valid_keylength (size_t length) const
| WiderWake_41_BE ()

## Detailed Description

WiderWake4+1-BE

Note: quite old and possibly not safe; use XSalsa20 or a block cipher in counter mode.

Definition at line 21 of file wid_wake.h.

## Constructor & Destructor Documentation

## ◆ WiderWake_41_BE()

Botan::WiderWake_41_BE::WiderWake_41_BE | ( |  | ) |
| inline

Definition at line 39 of file wid_wake.h.

39 : T(256), state(5), t_key(4),
40 buffer(DEFAULT_BUFFERSIZE), position(0)
41 {}

## Member Function Documentation

## ◆ cipher()

void Botan::WiderWake_41_BE::cipher | ( | const byte | in[],
|  | byte | out[],
|  | size_t | len
| ) |  |
| virtual

Encrypt or decrypt a message

Parameters

  in | the plaintext
  out | the byte array to hold the output, i.e. the ciphertext
  len | the length of both in and out in bytes

Implements Botan::StreamCipher.

Definition at line 17 of file wid_wake.cpp.

References Botan::load_be< u32bit >(), R0, R1, R2, R3, R4, set_iv(), Botan::MemoryRegion< T >::size(), Botan::store_be(), and Botan::xor_buf().

18 {
19 while(length >= buffer.size() - position)
20 {
21 xor_buf(out, in, &buffer[position], buffer.size() - position);
22 length -= (buffer.size() - position);
23 in += (buffer.size() - position);
24 out += (buffer.size() - position);
25 generate(buffer.size());
26 }
27 xor_buf(out, in, &buffer[position], length);
28 position += length;
29 }
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29
Botan::xor_buf
void xor_buf(byte out[], const byte in[], size_t length)
Definition: xor_buf.h:21

## ◆ cipher1()

void Botan::StreamCipher::cipher1 | ( | byte | buf[],
|  | size_t | len
| ) |  |
| inlineinherited

Encrypt or decrypt a message

Parameters

  buf | the plaintext / ciphertext
  len | the length of buf in bytes

Definition at line 34 of file stream_cipher.h.

Referenced by Botan::Lion::decrypt_n(), and Botan::Lion::encrypt_n().

35 { cipher(buf, buf, len); }
Botan::StreamCipher::cipher
virtual void cipher(const byte in[], byte out[], size_t len)=0

## ◆ clear()

void Botan::WiderWake_41_BE::clear | ( |  | ) |
| virtual

Zeroize internal state

Implements Botan::Algorithm.

Definition at line 143 of file wid_wake.cpp.

References Botan::zeroise().

144 {
145 position = 0;
146 zeroise(t_key);
147 zeroise(state);
148 zeroise(T);
149 zeroise(buffer);
150 }
Botan::zeroise
void zeroise(MemoryRegion< T > &vec)
Definition: secmem.h:415

## ◆ clone()

StreamCipher* Botan::WiderWake_41_BE::clone | ( |  | ) | const
| inlinevirtual

Get a new object representing the same algorithm as *this

Implements Botan::StreamCipher.

Definition at line 37 of file wid_wake.h.

37 { return new WiderWake_41_BE; }
Botan::WiderWake_41_BE::WiderWake_41_BE
WiderWake_41_BE()
Definition: wid_wake.h:39

## ◆ key_spec()

Key_Length_Specification Botan::WiderWake_41_BE::key_spec | ( |  | ) | const
| inlinevirtual

Returns
  object describing limits on key size

Implements Botan::SymmetricAlgorithm.

Definition at line 30 of file wid_wake.h.

31 {
32 return Key_Length_Specification(16);
33 }

## ◆ maximum_keylength()

size_t Botan::SymmetricAlgorithm::maximum_keylength | ( |  | ) | const
| inlineinherited

Returns
  minimum allowed key length

Definition at line 33 of file sym_algo.h.

Referenced by Botan::Cascade_Cipher::decrypt_n(), and Botan::ANSI_X931_RNG::randomize().

34 {
35 return key_spec().maximum_keylength();
36 }
Botan::Key_Length_Specification::maximum_keylength
size_t maximum_keylength() const
Definition: key_spec.h:69
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

## ◆ minimum_keylength()

size_t Botan::SymmetricAlgorithm::minimum_keylength | ( |  | ) | const
| inlineinherited

Returns
  maxmium allowed key length

Definition at line 41 of file sym_algo.h.

42 {
43 return key_spec().minimum_keylength();
44 }
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0
Botan::Key_Length_Specification::minimum_keylength
size_t minimum_keylength() const
Definition: key_spec.h:61

## ◆ name()

std::string Botan::WiderWake_41_BE::name | ( |  | ) | const
| inlinevirtual

Returns
  name of this algorithm

Implements Botan::Algorithm.

Definition at line 36 of file wid_wake.h.

Referenced by set_iv().

36 { return "WiderWake4+1-BE"; }

## ◆ set_iv()

void Botan::WiderWake_41_BE::set_iv | ( | const byte | iv[],
|  | size_t | iv_len
| ) |  |
| virtual

Resync the cipher using the IV

Parameters

  iv | the initialization vector
  iv_len | the length of the IV in bytes

Reimplemented from Botan::StreamCipher.

Definition at line 124 of file wid_wake.cpp.

References Botan::load_be< u32bit >(), name(), Botan::MemoryRegion< T >::size(), and valid_iv_length().

Referenced by cipher().

125 {
126 if(!valid_iv_length(length))
127 throw Invalid_IV_Length(name(), length);
128
129 for(size_t i = 0; i != 4; ++i)
130 state[i] = t_key[i];
131
132 state[4] = load_be<u32bit>(iv, 0);
133 state[0] ^= state[4];
134 state[2] ^= load_be<u32bit>(iv, 1);
135
136 generate(8*4);
137 generate(buffer.size());
138 }
Botan::WiderWake_41_BE::name
std::string name() const
Definition: wid_wake.h:36
Botan::load_be< u32bit >
u32bit load_be< u32bit >(const byte in[], size_t off)
Definition: loadstor.h:166
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29
Botan::WiderWake_41_BE::valid_iv_length
bool valid_iv_length(size_t iv_len) const
Definition: wid_wake.h:27

## ◆ set_key() [1/2]

void Botan::SymmetricAlgorithm::set_key | ( | const SymmetricKey & | key | ) |
| inlineinherited

Set the symmetric key of this object.

Parameters

  key | the SymmetricKey to be set.

Definition at line 60 of file sym_algo.h.

References Botan::OctetString::begin(), and Botan::OctetString::length().

Referenced by Botan::aont_unpackage(), Botan::CTR_BE::clear(), Botan::OFB::clear(), Botan::DESX::decrypt_n(), Botan::Cascade_Cipher::decrypt_n(), Botan::Lion::decrypt_n(), Botan::PKCS5_PBKDF2::derive_key(), Botan::ECB_Decryption::ECB_Decryption(), Botan::ECB_Encryption::ECB_Encryption(), Botan::Lion::encrypt_n(), Botan::HMAC_RNG::HMAC_RNG(), Botan::MAC_Filter::MAC_Filter(), Botan::ANSI_X931_RNG::randomize(), Botan::Randpool::randomize(), Botan::HMAC_RNG::reseed(), Botan::EAX_Base::set_key(), Botan::XTS_Encryption::set_key(), Botan::XTS_Decryption::set_key(), Botan::Record_Writer::set_keys(), Botan::Record_Reader::set_keys(), Botan::StreamCipher_Filter::StreamCipher_Filter(), Botan::DLIES_Decryptor::~DLIES_Decryptor(), and Botan::DLIES_Encryptor::~DLIES_Encryptor().

61 { set_key(key.begin(), key.length()); }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:60

## ◆ set_key() [2/2]

void Botan::SymmetricAlgorithm::set_key | ( | const byte | key[],
|  | size_t | length
| ) |  |
| inlineinherited

Set the symmetric key of this object.

Parameters

  key | the to be set as a byte array.
  length | in bytes of key param

Definition at line 68 of file sym_algo.h.

69 {
70 if(!valid_keylength(length))
71 throw Invalid_Key_Length(name(), length);
72 key_schedule(key, length);
73 }
Botan::SymmetricAlgorithm::valid_keylength
bool valid_keylength(size_t length) const
Definition: sym_algo.h:51
Botan::Algorithm::name
virtual std::string name() const =0

## ◆ valid_iv_length()

bool Botan::WiderWake_41_BE::valid_iv_length | ( | size_t | iv_len | ) | const
| inlinevirtual

Parameters

  iv_len | the length of the IV in bytes

Returns
  if the length is valid for this algorithm

Reimplemented from Botan::StreamCipher.

Definition at line 27 of file wid_wake.h.

Referenced by set_iv().

28 { return (iv_len == 8); }

## ◆ valid_keylength()

bool Botan::SymmetricAlgorithm::valid_keylength | ( | size_t | length | ) | const
| inlineinherited

Check whether a given key length is valid for this algorithm.

Parameters

  length | the key length to be checked.

Returns
  true if the key length is valid.

Definition at line 51 of file sym_algo.h.

Referenced by Botan::aont_unpackage(), Botan::HMAC_RNG::HMAC_RNG(), Botan::Lion::Lion(), and Botan::Randpool::Randpool().

52 {
53 return key_spec().valid_keylength(length);
54 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

The documentation for this class was generated from the following files:

- src/stream/wid_wake/wid_wake.h
- src/stream/wid_wake/wid_wake.cpp